bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: [PATCH] tail: fix a race condition


From: Giuseppe Scrivano
Subject: Re: [PATCH] tail: fix a race condition
Date: Tue, 20 Oct 2009 20:53:59 +0200
User-agent: Gnus/5.13 (Gnus v5.13) Emacs/23.1.50 (gnu/linux)

Jim Meyering <address@hidden> writes:

Thanks again for your notes.  I amended them into the patch.


Cheers,
Giuseppe



>From 3f0f5744899afc15e69554220be836f673b1dad3 Mon Sep 17 00:00:00 2001
From: Giuseppe Scrivano <address@hidden>
Date: Tue, 20 Oct 2009 10:49:17 +0200
Subject: [PATCH] tests: add a new test that checks for a possible `tail' race.

If new data is available between the initial read and tail registers the inotify
watch descriptors, ensure that it is read before a new event happens on the
file.

* tests/Makefile.am (TESTS): Add tail-2/inotify-race.
* tests/tail-2/inotify-race: New file.
---
 tests/Makefile.am         |    1 +
 tests/tail-2/inotify-race |   69 +++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 70 insertions(+), 0 deletions(-)
 create mode 100755 tests/tail-2/inotify-race

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 751db1c..bb11c23 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -74,6 +74,7 @@ EXTRA_DIST += $(TESTS)
 
 TESTS =                                                \
   misc/help-version                            \
+  tail-2/inotify-race                          \
   misc/invalid-opt                             \
   rm/ext3-perf                                 \
   rm/cycle                                     \
diff --git a/tests/tail-2/inotify-race b/tests/tail-2/inotify-race
new file mode 100755
index 0000000..47129db
--- /dev/null
+++ b/tests/tail-2/inotify-race
@@ -0,0 +1,69 @@
+#!/bin/sh
+# Copyright (C) 2006, 2009 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+
+# Ensure that tail does not ignore data that is appended to a tailed-forever
+# file between tail's initial read-to-EOF, and when the inotify watches
+# are established in tail_forever_inotify.  That data could be ignored
+# indefinitely if no *other* data is appended, but it would be printed as
+# soon as any additional appended data is detected.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  tail --version
+fi
+
+. $srcdir/test-lib.sh
+
+fail=0
+
+touch file || framework_failure
+touch tail.out || framework_failure
+
+( gdb --version ) > gdb.out 2>&1
+case $(cat gdb.out) in
+    'GNU gdb'*) ;;
+    *) skip_test_ "can't run gdb";;
+esac
+
+
+# See if gdb works:
+
+gdb -nx --batch-silent              \
+    --eval-command='break tail_forever_inotify'    \
+    --eval-command='run -f file'    \
+    --eval-command='quit'    \
+    $abs_top_builddir/src/tail < /dev/null > gdb.out 2>&1
+
+test -s gdb.out && skip_test_ "can't set breakpoints in tail"
+
+
+timeout 10s gdb -nx --batch-silent    \
+    --eval-command='break tail_forever_inotify'    \
+    --eval-command='run -f file  >> tail.out'    \
+    --eval-command="shell echo never-seen-with-tail-7.5 >> file" \
+    --eval-command='continue' \
+    --eval-command='quit'    \
+    $abs_top_builddir/src/tail < /dev/null &
+pid=$!
+
+tail --pid=$pid -f tail.out | (read; kill $pid)
+
+test -s tail.out || fail=1
+
+Exit $fail
-- 
1.6.3.3






reply via email to

[Prev in Thread] Current Thread [Next in Thread]